<template>
  <div class="container activity-log-section py-5">
    <div class="recent-reward">
      <div class="row pb-5">
        <div class="col">
          <h2>Recent Rewards</h2>
        </div>
      </div>
      <div class="row border border-danger border-3 mb-5 px-3 px-lg-0">
        <div class="col col-12 col-lg-6 bitcoin-tab">
          <div class="row">
            <div class="col col-2 ps-2 ps-lg-4 my-2 d-flex align-items-center">
              <img src="@/assets/img/bitcoin-icon.png" class="w-100" style="object-fit: contain;"/>
            </div>
            <div class="col col-9 my-2 d-flex align-items-center">
              <p class="text-danger fw-bold m-0 skiptranslate">0.00000000 BTC</p>
            </div>
          </div>
        </div>
        <div class="col col-12 col-lg-6 bsbt-tab">
          <div class="row border-danger border-3">
            <div
              class="col col-2 ps-2 ps-lg-4 my-2 border-start border-danger border-3 d-flex align-items-center"
            >
              <img src="@/assets/img/bsbt-icon.png" class="w-100" style="object-fit: contain;"/>
            </div>
            <div class="col col-9 my-2 d-flex align-items-center">
              <p class="text-danger fw-bold m-0 ">0.00000000 BSBT</p>
            </div>
          </div>
        </div>
      </div>
    </div>

    <div v-if="joinQuizCurrentPage.length || myQuizCurrentPage.length" class="activity-logs">
      <div class="row pb-5">
        <div class="col">
          <h2>Activity logs</h2>
        </div>
      </div>
      
      <ul class="nav nav-tabs" id="myTab" role="tablist">
        <li v-if="joinQuizCurrentPage.length" class="nav-item" role="presentation">
          <button
            class="nav-link active"
            id="home-tab"
            data-bs-toggle="tab"
            data-bs-target="#home"
            type="button"
            role="tab"
            aria-controls="home"
            aria-selected="true"
          >
            Last Quiz 
          </button>
        </li>
        <li v-if="joinQuizCurrentPage.length" class="nav-item d-none" role="presentation">
          <button
            class="nav-link"
            id="profile-tab"
            data-bs-toggle="tab"
            data-bs-target="#profile"
            type="button"
            role="tab"
            aria-controls="profile"
            aria-selected="false"
          >
            Last Survey
          </button>
        </li>
        <li v-if="myQuizCurrentPage.length" class="nav-item" role="presentation">
          <button
            class="nav-link"
            id="contact-tab"
            data-bs-toggle="tab"
            data-bs-target="#contact"
            type="button"
            role="tab"
            aria-controls="contact"
            aria-selected="false"
          >
            My Quiz
          </button>
        </li>
        <li v-if="joinQuizCurrentPage.length" class="nav-item d-none" role="presentation">
          <button
            class="nav-link"
            id="contact-tab"
            data-bs-toggle="tab"
            data-bs-target="#contact1"
            type="button"
            role="tab"
            aria-controls="contact"
            aria-selected="false"
          >
            My Survey
          </button>
        </li>
      </ul>
      <div class="tab-content" id="myTabContent">
        <div
          class="tab-pane fade show active"
          id="home"
          role="tabpanel"
          aria-labelledby="home-tab"
        >
          <vue-table
            ref="vuetablequiz"
            :fields="fieldTableQuiz"
            :css="cssTable.table"
            :data="joinQuizCurrentPage"
            :api-mode="false"
            :first-page="0"
          ></vue-table>
          <div class="paginate">
            <paginate class="row-paginate"
            :page-count="page_count"
            :click-handler="paginate"
            :prev-text="'<'"
            :next-text="'>'"
            :container-class="'className'"
            :next-class="'nextBtn'"
            :page-class="'pageBtn'"
            :prev-class="'prevBtn'"
            >
            </paginate>
          </div>
        </div>
        <div
          class="tab-pane fade"
          id="profile"
          role="tabpanel"
          aria-labelledby="profile-tab"
        >
          Comming soon
        </div>
        <div
          class="tab-pane fade"
          id="contact"
          role="tabpanel"
          aria-labelledby="contact-tab"
        >
          <vue-table
            ref="vuetablequiz"
            :fields="fieldTableMyQuiz"
            :css="cssTable.table"
            :data="myQuizCurrentPage"
            :api-mode="false"
            :first-page="0"
          ></vue-table>
          <div class="paginate">
            <paginate class="row-paginate"
            :page-count="total_count_myquiz"
            :click-handler="paginate"
            :prev-text="'<'"
            :next-text="'>'"
            :container-class="'className'"
            :next-class="'nextBtn'"
            :page-class="'pageBtn'"
            :prev-class="'prevBtn'"
            >
            </paginate>
          </div>
        </div>
        <div
          class="tab-pane fade"
          id="contact1"
          role="tabpanel"
          aria-labelledby="contact-tab"
        >
          Comming Soon
        </div>
      </div>

    </div>
  </div>
</template>

<script>
import VueTable from "vuetable-2";
import { apiCustomerGet, apiCustomerPost } from "../services/baseApi";
import Paginate from 'vuejs-paginate'

const cssTable = {
  table: {
    tableWrapper: "table-responsive",
    tableHeaderClass: "",
    tableBodyClass: "",
    tableClass: "table table-hover table-striped table-borderless",
    loadingClass: "",
    ascendingIcon: "",
    descendingIcon: "",
    ascendingClass: "",
    descendingClass: "",
    sortableIcon: "",
    handleIcon: "",
  },
};

export default {
  components: {
    VueTable,
    Paginate
  },
  data() {
    return {
      fieldTableQuiz: ["day", "type", "amount", "BSBT"],
      dataTableQuiz: [],
      cssTable,
      page: 1,
      page_count: 0,
      total_count_myquiz: 0,
      fieldTableMyQuiz: ["day", "type", "approve", "BSBT"],
      dataTableMyQuiz: [],
      perPage: 4,
      joinQuizCurrentPage: [],
      myQuizCurrentPage: []
    };
  },
  mounted() {
    this.getListJoinQuiz()
    this.getListMyQuiz()
  },
  methods: {
    async getListJoinQuiz () {
      try {
        const customer_id = JSON.parse(localStorage.getItem('user'))
        const getAll = await apiCustomerPost('quiz-reward/get-list', {
          search: {
            customer_id: customer_id.id
          },
          limit: 0
        })
        this.page_count = Math.ceil(getAll.data.data.quiz_rewards.length / 4)
        getAll.data.data.quiz_rewards.map((item) => {
          this.dataTableQuiz.push({
            day: this.$options.filters.formatDateMonth(parseInt(item.end_date)),
            type: '1 Minute Quiz',
            amount: item.count_correct_answer,
            BSBT: item.reward_bsbt || 0
          })
        })
        this.listJoinQuizPerpage()
      } catch (error) {
        console.log(error);
      }
    },

    listJoinQuizPerpage () {
      let indStart = (this.page - 1) * this.perPage;
      let indEnd = this.page * this.perPage;
      this.joinQuizCurrentPage = this.dataTableQuiz.slice(indStart, indEnd);
    },

    listMyQuizPerpage () {
      let indStart = (this.page - 1) * this.perPage;
      let indEnd = this.page * this.perPage;
      this.myQuizCurrentPage = this.dataTableMyQuiz.slice(indStart, indEnd);
    },

    async getListMyQuiz () {
      try {
        const created_by = JSON.parse(localStorage.getItem('user'))
        console.log(created_by);
        const getAll = await apiCustomerGet('quizz/my-quiz', { created_by: created_by.id, limit: 0 }, { token: localStorage.getItem("token") })
        this.total_count_myquiz = Math.ceil(getAll.data.data.quizzs.length / 4)
        getAll.data.data.quizzs.map(item => {
          this.dataTableMyQuiz.push({
            day: this.$options.filters.formatDateMonth(parseInt(item.createdAt+'000')),
            type: "1 Minute Quiz",
            approve: item.approve ? 'Accept' : 'Pending',
            BSBT: item.reward_bsbt || 0
          })
        })
        this.listMyQuizPerpage()
      } catch (error) {
        console.log(error);
      }
    },

    paginate(page) {
      this.page = page
      this.dataTableQuiz = []
      this.dataTableMyQuiz = []
      this.getListJoinQuiz()
      this.getListMyQuiz()
    },

    prevPage() {
      if (this.page == 1) {
        this.page = 1
      } else {
        this.page--
        this.dataTableQuiz = []
        this.getListJoinQuiz()
      }
    },
  },
};
</script>
<style>
  .nextBtn, .prevBtn {
    color:gray;
    font-weight: 700;
    outline: none;
  }
  .nextBtn a, .prevBtn a {
    outline: none;
  }
  .pageBtn {
    border: 1px solid grey;
    border-radius: 5px;
    padding: 0px 7px;
    margin: 0px 5px;
    outline: none;
  }
  .pageBtn a {
    outline: none;
    color: unset;
    text-decoration: none;
  }
</style>
<style scoped>

.nav-tabs .nav-link {
  border-color: #dc3545;
  color: #dc3545;
}
.nav-tabs .nav-link.active {
  background: #dc3545;
  color: white;
}
.nav-item:last-child .nav-link {
  padding-right: 15px;
}
.tab-pane {
  background: none !important;
}
.nav-tabs {
  border-bottom: 2px solid #dc3545;
}
.nav-tabs .nav-link {
  margin-bottom: 0px;
}
.nav-item:first-child .nav-link {
  padding-left: 15px ;
}
.vuetable {
  min-height: 150px;
}
.paginate {
  position: relative;
  margin-bottom: 20px;
}
.row-paginate {
  display: flex;
  list-style-type: none;
  position: absolute;
  right: 0;
}
.activity-log-section .action-tab .nav-link {
  padding: 0.5rem 1.2rem !important;
  border-radius: 16px 16px 0 0;
}
.activity-log-section .pagination-tab .nav-link {
  padding: 0.5rem 1rem !important;
}
.activity-log-section .pagination-tab .nav-item:last-child .nav-link {
  font-size: 1.6rem;
  padding-top: 0 !important;
  padding-bottom: 0 !important;
}
.recent-reward .row:nth-child(2) {
  border-radius: 22px;
}
.recent-reward p {
  font-size: 32px;
}
@media (max-width: 991px) {
  .recent-reward .bsbt-tab .row {
    border-width: 3px 0 0 0 !important;
    border-style: solid;
  }
  .recent-reward .bsbt-tab .row .col {
    border: none !important;
  }
  .activity-log-section .action-tab .nav-link {
    padding: 0.5rem 0.4rem !important;
    border-radius: 16px 16px 0 0;
    font-size: 0.9rem;
  }
  .activity-log-section .action-tab + div {
    top: unset !important;
    bottom: -30px;
  }
}

@media (max-width: 470px) {
  .nav-tabs .nav-link {
    padding: 10px;
  }
}

@media (max-width: 429px) {
  .nav-tabs .nav-link {
    padding: 3px;
    font-size: 12px;
  }
  .nav-item:first-child .nav-link {
    padding-left: 5px;
  }
  .nav-item:last-child .nav-link {
    padding-right: 3px;
  }
}
</style>
